package com.gct.tools.etlcamelhuge.routeconfig;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.util.SGTUtil;
import com.gct.tools.etlcamelhuge.entity.ZDJG_WELL;
import com.gct.tools.etlcamelhuge.util.CALUtil;
import com.gct.tools.etlcamelhuge.util.TransUtil;
import org.apache.camel.Message;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.core.JdbcTemplate;

import javax.annotation.Resource;
import javax.sql.DataSource;
import java.io.*;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;


@Configuration
public class CamelRestConfiguration extends RouteBuilder {


    private static Map<String, String> accessWellMap = new HashMap();

    public String gtTransUtil(String gtdata)//处理示功图
    {
        String gt = "";
        if (gtdata == null) {
            gtdata = "";
        }

        Double[][] doubles = null;
        int len = gtdata.length() / 8;
        if (!gtdata.equals("")) {
            for (int i = 0; i < len; i++) {
                gt += String.valueOf(Double.parseDouble(gtdata.substring(i * 8, i * 8 + 3)) / 100) + ",";
                if (i == len - 1) {
                    gt += String.valueOf(Double.parseDouble(gtdata.substring(i * 8 + 3, i * 8 + 8)) / 100);
                } else {
                    gt += String.valueOf(Double.parseDouble(gtdata.substring(i * 8 + 3, i * 8 + 8)) / 100) + ",";
                }
            }

            String[] s = gt.split(",");
            String w = "";
            for (int i = 0; i < s.length; i++) {
                w += new BigDecimal(Math.round(Double.parseDouble(s[i]) * 100)).stripTrailingZeros().toPlainString() + ",";
            }
            doubles = SGTUtil.encodeToDoubleArray(w);

        }
        String string = SGTUtil.encodeToString(doubles);
        return string;
    }

    public String getDate() {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//设置日期格式
        String date = df.format(new java.util.Date());// new Date()为获取当前系统时间
        return date;
    }


    public void getCurrentTimeParams(String wellId, String wellName, String date) throws Exception {

        Map<String, Double> map = new HashMap<>();

        String ACurrent = "/upData/A相电流";
        String BCurrent = "/upData/B相电流";
        String CCurrent = "/upData/C相电流";
        String APress = "/upData/A相电压";
        String BPress = "/upData/B相电压";
        String CPress = "/upData/C相电压";
        String noTotalPower = "/upData/总无功功率";
        String totalPower = "/upData/总有功功率";
        String casePress = "/upData/套压";
        String oilPress = "/upData/油压";
        System.out.println("开始 :wellId: " + wellId + "wellName:" + wellName + "date" + date + "sysdate" + new Date());
        map.put("ACurrent", Double.valueOf("".equals(getParams(wellId + ACurrent)) ? "0" : getParams(wellId + ACurrent)));
        map.put("BCurrent", Double.valueOf("".equals(getParams(wellId + BCurrent)) ? "0" : getParams(wellId + BCurrent)));
        map.put("CCurrent", Double.valueOf("".equals(getParams(wellId + CCurrent)) ? "0" : getParams(wellId + CCurrent)));
        map.put("APress", Double.valueOf("".equals(getParams(wellId + APress)) ? "0" : getParams(wellId + APress)));
        map.put("BPress", Double.valueOf("".equals(getParams(wellId + BPress)) ? "0" : getParams(wellId + BPress)));
        map.put("CPress", Double.valueOf("".equals(getParams(wellId + CPress)) ? "0" : getParams(wellId + CPress)));
        map.put("noTotalPower", Double.valueOf("".equals(getParams(wellId + noTotalPower)) ? "0" : getParams(wellId + noTotalPower)));
        map.put("totalPower", Double.valueOf("".equals(getParams(wellId + totalPower)) ? "0" : getParams(wellId + totalPower)));
        map.put("casePress", Double.valueOf("".equals(getParams(wellId + casePress)) ? "0" : getParams(wellId + casePress)));
        map.put("oilPress", Double.valueOf("".equals(getParams(wellId + oilPress)) ? "0" : getParams(wellId + oilPress)));
        System.out.println("over");
        insertCurrentTimeParams(map, wellName, date);


    }

    public void insertCurrentTimeParams(Map<String, Double> map, String wellName, String date) {

        JdbcTemplate jdbcTemplate = new JdbcTemplate(baseDataSource);
        String sql = "INSERT INTO centralbase.cb_pc_current_time_params (well_name, prod_date,a_current, b_current, c_current, a_press, b_press, c_press, no_total_power, total_power, case_press, oil_press) " +
                "VALUES ('" + wellName + "','" + date + "'," + (map.get("ACurrent") == 0 ? null : map.get("ACurrent")) + "," + (map.get("BCurrent") == 0 ? null : map.get("BCurrent")) + "," + (map.get("CCurrent") == 0 ? null : map.get("CCurrent")) + "," + (map.get("APress") == 0 ? null : map.get("APress")) + "," + (map.get("BPress") == 0 ? null : map.get("BPress")) + ","
                + (map.get("CPress") == 0 ? null : map.get("CPress")) + "," + (map.get("noTotalPower") == 0 ? null : map.get("noTotalPower")) + "," + (map.get("totalPower") == 0 ? null : map.get("totalPower")) + "," + (map.get("casePress") == 0 ? null : map.get("casePress")) + "," + (map.get("oilPress") == 0 ? null : map.get("oilPress")) + ")  ON CONFLICT (well_name,prod_date)  DO NOTHING;";
        if (accessWellMap.get(wellName) != null)
            jdbcTemplate.update(sql);
    }


    public String getParams(String param) throws Exception {
        URL restURL = new URL("http://11.72.128.71/api-service/tsdb/getLast?appKey=MOsEWVl8S0");

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("POST");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());
        String content = "id=" + URLEncoder.encode(param, "UTF-8");
        out.writeBytes(content);
        out.flush();
        out.close();
        PrintStream ps = new PrintStream(conn.getOutputStream());

        ps.close();

        InputStream is = null;
        if (conn.getResponseCode() == 200) {
            is = conn.getInputStream();
        } else {
            is = conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
        String line;
        StringBuilder resultStr = new StringBuilder();
        while (null != (line = bReader.readLine())) {
            resultStr.append(line);
        }

        String value = "";
        JSONObject json = null;
        try {
            json = JSONObject.parseObject(resultStr.toString());

            if (json.size() > 0) {
                value = json.get("value").toString();
            }

        } catch (Exception e) {
        }
        return value;
    }


    public String loadPhdDate(String well_id) throws Exception {
        URL restURL = new URL("http://11.72.128.71/api-service/tsdb/getLast?appKey=MOsEWVl8S0");

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("POST");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());
        String content = "id=" + URLEncoder.encode(well_id + "/upData/电流平衡率", "UTF-8");
        out.writeBytes(content);
        out.flush();
        out.close();
        PrintStream ps = new PrintStream(conn.getOutputStream());

        ps.close();

        InputStream is = null;
        if (conn.getResponseCode() == 200) {
            is = conn.getInputStream();
        } else {
            is = conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
        List<String> list = new ArrayList<>();

        String line, resultStr = "";
        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }

        String value = "";
        JSONObject json = null;
        try {
            json = JSONObject.parseObject(resultStr);

            if (json.size() > 0) {
                value = json.get("value").toString();
            }

        } catch (Exception e) {
            e.printStackTrace();
//            System.out.println(resultStr);
        }
//        System.out.println(value);
        return value;
    }

    @Resource(name = "centralbase")
    DataSource baseDataSource;


    public void insertData(ZDJG_WELL z) {
        JdbcTemplate jdbcTemplate = new JdbcTemplate(baseDataSource);
        String sql = "INSERT INTO centralbase.collection_time_error (well_id, prod_date,rut_time, stroke_length, stroke_frequency, susp_max_load, susp_min_load, sgt, error_log) " +
                "VALUES ('" + z.getWell_common_name() + "','" + z.getProd_date() + "','" + z.getBz() + "','" + z.getStroke() + "','" + z.getFrequence() + "','" + z.getSxzh() + "','" + z.getXxzh() + "','" + z.getZd_init_sgt() + "','" + z.getErrorInfo() + "')  ON CONFLICT (well_id,prod_date)  DO NOTHING;";
        jdbcTemplate.update(sql);
    }

    public void getAccessWell() {
        JdbcTemplate jdbcTemplate = new JdbcTemplate(baseDataSource);
        String sql = "SELECT well_id wellid FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1' ";
        List<String> accessWells = jdbcTemplate.queryForList(sql, String.class);

        accessWells.forEach(x -> {
            accessWellMap.put(x, x);
        });
    }

    public static void main(String[] args) {
        System.out.println(URLEncoder.encode("红004"));
    }


    public ZDJG_WELL loadGtDataNew(String param, String well_id, String sysDate) throws Exception {
//        String date = getDate();

        URL restURL = new URL("http://11.72.128.71/script/gt?userId=ADF2IoxMsn&names=" + URLEncoder.encode(well_id));

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("GET");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(false);
        conn.setDoInput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);

        InputStream is = null;
        if (conn.getResponseCode() == 200) {
            is = conn.getInputStream();
        } else {
            is = conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
        String line, resultStr = "";
        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }

        ZDJG_WELL z = new ZDJG_WELL();
        JSONObject json = null;
        try {
            JSONArray ja = JSONArray.parseArray(resultStr);
            if (!ja.isEmpty()) {
                json = ja.getJSONObject(0);
//                System.out.println("step2 ============"+json);
                String value = json.get("data").toString();
                String time = json.get("time").toString();
                time = time.replace("Z", " UTC"); //2019-06-27T16:00:00.000 UTC
                SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS Z");//转换时区格式
                Date cjDate = format1.parse(time);
                SimpleDateFormat fomat2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                SimpleDateFormat fomat3 = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                String mydate = fomat2.format(cjDate);
                JSONObject json2 = JSONObject.parseObject(value);
                String bool = json2.getString("state").toString();
                z.setIs_device_close(bool.equals("true") ? "在线" : "不在线");
                z.setIs_well_close("关井");
                if (!bool.equals("false")) {
                    String data = json2.get("data").toString();
                    JSONObject jsonObject = JSONObject.parseObject(data);
//                    String offset = jsonObject.getString("offset");
                    String jh = well_id.replace(" ", "");
                    z.setWell_common_name(jh);
                    String gtsj = TransUtil.tranSGT(jsonObject.getString("offset"), jsonObject.getString("load"));
                    Date timeRtu = null;
                    String rtutime = jsonObject.getString("time");
                    timeRtu = fomat3.parse("0000-00-00 00:".equals(rtutime) ? "2021-04-10 10:10" : rtutime);
                    Date yunpingtai = fomat2.parse(mydate);
                    long time1 = timeRtu.getTime();
                    long time2 = yunpingtai.getTime();
                    Date date = new Date();
                    long time3 = date.getTime();
                    int hours1 = (int) ((time3 - time2) / (1000 * 60 * 60));
                    int hours = (int) ((time2 - time1) / (1000 * 60 * 60));
                    //云平台和采集时间相差要小于4小时
//                    if (hours < 4 && !"".equals(gtsj) && hours1 < 4) {
                        z.setZd_init_sgt(gtsj);//位移载荷点
                        z.setProd_date(time.substring(0,10)+' '+time.substring(11,18));
//                        z.setSys_date(sysDate);
//                        z.setIs_well_close(Double.valueOf(jsonObject.getString("minCurrent")) > 0 ? "开井": "关井");
//                        z.setPressure(0);
                        if (jsonObject.getString("strokeFrequency") != null) {
                            z.setStroke(CALUtil.round((Double.valueOf(jsonObject.getString("strokeFrequency"))) * 100) / 100);//冲程，但GTSB_2的冲程是CC字段
                        }
                        if (jsonObject.getString("stroke") != null) {
                            z.setFrequence(CALUtil.round((Double.valueOf(jsonObject.getString("stroke"))) * 100) / 100);//冲次，但GTSB_2的冲次是PJXC字段
                        }
                        z.setSxzh(Double.parseDouble(jsonObject.getString("maxLoad")));//最大载荷
                        z.setXxzh(Double.parseDouble(jsonObject.getString("minLoad")));//最小载荷
                        z.setWell_common_name(well_id);
                    }
//                System.out.println("step 3 ===="+z);
//                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        bReader.close();
        is.close();
        return z;
    }

    @Deprecated
    public ZDJG_WELL loadGtData(String param, String well_id, String sysDate) throws Exception {
//        String date = getDate();

        URL restURL = new URL("http://11.72.128.71/api-service/tsdb/getLast?appKey=MOsEWVl8S0");

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("POST");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());
        String content = "id=" + URLEncoder.encode(param, "UTF-8");
        out.writeBytes(content);
        out.flush();
        out.close();
        PrintStream ps = new PrintStream(conn.getOutputStream());

        ps.close();

        InputStream is = null;
        if (conn.getResponseCode() == 200) {
            is = conn.getInputStream();
        } else {
            is = conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
        String line, resultStr = "";
        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }

        ZDJG_WELL z = new ZDJG_WELL();
        JSONObject json = null;
        try {
            json = JSONObject.parseObject(resultStr);

            if (json.size() > 0) {
                String value = json.get("value").toString();
                String time = json.get("time").toString();
                time = time.replace("Z", " UTC"); //2019-06-27T16:00:00.000 UTC
                SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS Z");//转换时区格式
                Date cjDate = format1.parse(time);
                SimpleDateFormat fomat2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                SimpleDateFormat fomat3 = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                String mydate = fomat2.format(cjDate);
                JSONObject json2 = JSONObject.parseObject(value);
                String bool = json2.getString("state").toString();
                z.setIs_device_close(bool.equals("true") ? "在线" : "不在线");
                z.setIs_well_close("关井");
                if (!bool.equals("false")) {
                    String data = json2.get("data").toString();
                    JSONObject jsonObject = JSONObject.parseObject(data);
//                    String offset = jsonObject.getString("offset");
                    String jh = well_id.replace(" ", "");
                    z.setWell_common_name(jh);
                    String gtsj = TransUtil.tranSGT(jsonObject.getString("offset"), jsonObject.getString("load"));
                    Date timeRtu = null;
                    String rtutime = jsonObject.getString("time");
                    timeRtu = fomat3.parse("0000-00-00 00:".equals(rtutime) ? "2021-04-10 10:10" : rtutime);
                    Date yunpingtai = fomat2.parse(mydate);
                    long time1 = timeRtu.getTime();
                    long time2 = yunpingtai.getTime();
                    Date date = new Date();
                    long time3 = date.getTime();
                    int hours1 = Math.abs((int) ((time3 - time2) / (1000 * 60 * 60)));
                    int hours = Math.abs((int) ((time2 - time1) / (1000 * 60 * 60)));
                    //云平台和采集时间相差要小于4小时
                    if (hours < 4 && !"".equals(gtsj) && hours1 < 4) {
                        z.setZd_init_sgt(gtsj);//位移载荷点
//
                        if (jsonObject.getString("strokeFrequency") != null) {
                            z.setStroke(CALUtil.round((Double.valueOf(jsonObject.getString("stroke"))) * 100) / 100);//冲程，但GTSB_2的冲程是CC字段
                        }
                        if (jsonObject.getString("stroke") != null) {
                            z.setFrequence(CALUtil.round((Double.valueOf(jsonObject.getString("strokeFrequency"))) * 100) / 100);//冲次，但GTSB_2的冲次是PJXC字段
                        }
                        z.setSxzh(Double.parseDouble(jsonObject.getString("maxLoad")));//最大载荷
                        z.setXxzh(Double.parseDouble(jsonObject.getString("minLoad")));//最小载荷
                        z.setWell_common_name(well_id);
                    } else {
                        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式
                        String dateNow = df.format(new java.util.Date());
                        ZDJG_WELL well = new ZDJG_WELL();
                        well.setZd_init_sgt(gtsj);//位移载荷点
//
                        if (jsonObject.getString("strokeFrequency") != null) {
                            well.setStroke(CALUtil.round((Double.valueOf(jsonObject.getString("stroke"))) * 100) / 100);//冲程，但GTSB_2的冲程是CC字段
                        }
                        if (jsonObject.getString("stroke") != null) {
                            well.setFrequence(CALUtil.round((Double.valueOf(jsonObject.getString("strokeFrequency"))) * 100) / 100);//冲次，但GTSB_2的冲次是PJXC字段
                        }
                        well.setProd_date(dateNow);
                        well.setBz(rtutime);
                        well.setSxzh(Double.parseDouble(jsonObject.getString("maxLoad")));//最大载荷
                        well.setXxzh(Double.parseDouble(jsonObject.getString("minLoad")));//最小载荷
                        well.setWell_common_name(well_id);

                        well.setErrorInfo("采集时间错误");
                        if (accessWellMap.get(well.getWell_common_name()) != null)
                            insertData(well);
                    }

                }
            }
        } catch (Exception e) {
//            System.out.println(resultStr);
        }
        bReader.close();
        is.close();
        return z;
    }

    @Override
    public synchronized void configure() throws Exception {
        getAccessWell();
        Map<String, String> map = new HashMap<>();
        restConfiguration()
                .component("servlet")
                .host("11.72.128.71");
        from("timer:mytimer?period=3600000")
                .setBody(simple("select well_id from centralbase.cb_cd_well_source"))
                .to("jdbc:centralbase")
                .split(body()).process(
                        exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            in.setHeader("well_id", aRow.get("well_id"));
//                            System.out.println("step 1 =============="+aRow.get("well_id"));
                            in.setHeader("date", getDate());
//                            map.put("date", in.getHeader("date").toString());
//                            getCurrentTimeParams("", aRow.get("well_id").toString(), map.get("date"));
//                            Double phd = "".equals(loadPhdDate(aRow.get("id").toString())) ? 0 : Double.valueOf(loadPhdDate(aRow.get("id").toString()));
                            ZDJG_WELL zdjg_well = loadGtDataNew("", aRow.get("well_id").toString(), "");
                            aRow.put("sgt", zdjg_well.getZd_init_sgt());//null
                            aRow.put("susp_max_load", zdjg_well.getSxzh());//最大载荷
                            aRow.put("susp_min_load", zdjg_well.getXxzh());//最小载荷
                            aRow.put("stroke", zdjg_well.getStroke());
                            aRow.put("frequency", zdjg_well.getFrequence());
                            aRow.put("dyna_create_time", zdjg_well.getProd_date());
                            aRow.put("well_name", zdjg_well.getStroke() == 0 || zdjg_well.getSxzh() == 0 ? "No01" : aRow.get("well_id"));
                            aRow.put("phd",0);
                        })
//                .log("${body[phd]}"+ "sql" + "${body[well_name]}")
//                .filter(simple("${body[well_name]} != 'No01'"))
                .doTry()
                .setBody(simple("insert into centralbase.cb_temp_well_mech_runtime(well_id,prod_date,stroke_length,stroke_frequency,susp_max_load,susp_min_load,sgt,elec_pump_current_b) " +
                        "values( '${body[well_name]}','${in.header.date}','${body[stroke]}','${body[frequency]}','${body[susp_max_load]}','${body[susp_min_load]}','${body[sgt]}','${body[phd]}')  "))
//                        "where NOT EXISTS (SELECT * FROM centralbase.cb_temp_well_mech_runtime WHERE well_id = '${body[well_name]}' and  prod_date = '${in.header.date}' )"))
                .to("jdbc:centralbase")
                .doCatch(Exception.class)
                .end();
    }
}